// print_from_ptrs.cpp
// Glenn G. Chappell
// 20 Sep 2013
//
// For CS 202 Fall 2013
// Program for you to finish
// Used in Assignment 2, Exercise C

// *************************************
// * Finish writing function printAll. *
// * Do not modify any other part of   *
// * this program.                     *
// *************************************

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <vector>
using std::vector;
#include <string>
using std::string;
#include <cstdlib>
using std::size_t;


// PrintSomething
// Object maintains a message, which can be set by client code and
//  printed by the object (to cout, followed by a newline).
class PrintSomething {
// ***** PrintSometing: Ctors, dctor *****
public:

    // Default ctor & ctor from string
    // Set messsage to given string.
    PrintSomething(const string & msg = "")
    {
        setMsg(msg);
    }

    // Compiler-generated dctor used


// ***** PrintSometing: General public functions *****
public:

    // setMsg
    // Set messsage to given string.
    void setMsg(const string & msg)
    {
        _msg = msg;
    }

    // doPrint
    // Output message to cout, followed by newline.
    void doPrint() const
    {
        cout << _msg << endl;
    }

// ***** PrintSometing: Member variables *****
private:

    string _msg;  // The message

};  // End class PrintSomething


// printAll
// Given a vector of (PrintSomething *), each of which points to a
//  PrintSomething object, calls member function doPrint on each
//  PrintSomething object, in the order the pointers are given in the
//  vector.
////////////////////////////////////////////////////////////////////////
// THE PART YOU MODIFY STARTS HERE

void printAll(???)
{
    ???
}
// THE PART YOU MODIFY ENDS HERE
////////////////////////////////////////////////////////////////////////


// main
// Make a vector of dynamically allocated PrintSomething objects,
//  call printAll to print all their messages, clean up.
int main()
{
    // Make a vector of pointers to PrintSomething objects,
    //  each with its own message
    vector<PrintSomething *> ps;
    ps.push_back(new PrintSomething("Four score and seven"));
    ps.push_back(new PrintSomething("years ago"));
    ps.push_back(new PrintSomething("our dogs and cats"));
    ps.push_back(new PrintSomething("had, like, this huge fight."));
    ps.push_back(new PrintSomething("And it was totally insane."));
    ps.push_back(new PrintSomething("I mean"));
    ps.push_back(new PrintSomething("totally."));

    // Print all the messages
    printAll(ps);

    // Clean up now, because we're GOOD people here, right?
    for (size_t i = 0; i < ps.size(); ++i)
    {
        delete ps[i];
    }

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

